<?php

declare(strict_types=1);

namespace App\Policies;

use App\Models\DelayedGood;
use Illuminate\Auth\Access\HandlesAuthorization;
use Illuminate\Foundation\Auth\User as AuthUser;

class DelayedGoodPolicy
{
    use HandlesAuthorization;

    public function viewAny(AuthUser $authUser): bool
    {
        return $authUser->can('ViewAny:DelayedGood');
    }

    public function view(AuthUser $authUser, DelayedGood $delayedGood): bool
    {
        return $authUser->can('View:DelayedGood');
    }

    public function create(AuthUser $authUser): bool
    {
        return $authUser->can('Create:DelayedGood');
    }

    public function update(AuthUser $authUser, DelayedGood $delayedGood): bool
    {
        return $authUser->can('Update:DelayedGood');
    }

    public function delete(AuthUser $authUser, DelayedGood $delayedGood): bool
    {
        return $authUser->can('Delete:DelayedGood');
    }

    public function restore(AuthUser $authUser, DelayedGood $delayedGood): bool
    {
        return $authUser->can('Restore:DelayedGood');
    }

    public function forceDelete(AuthUser $authUser, DelayedGood $delayedGood): bool
    {
        return $authUser->can('ForceDelete:DelayedGood');
    }

    public function forceDeleteAny(AuthUser $authUser): bool
    {
        return $authUser->can('ForceDeleteAny:DelayedGood');
    }

    public function restoreAny(AuthUser $authUser): bool
    {
        return $authUser->can('RestoreAny:DelayedGood');
    }

    public function replicate(AuthUser $authUser, DelayedGood $delayedGood): bool
    {
        return $authUser->can('Replicate:DelayedGood');
    }

    public function reorder(AuthUser $authUser): bool
    {
        return $authUser->can('Reorder:DelayedGood');
    }
}
